//---------------------------------------------------------------------------

#include "Splash.h"
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
USEFORM("NetSenderForm.cpp", H2ONetSender);
USEFORM("Splash.cpp", Splash_dlg);
USEFORM("Historique.cpp", HistoriqueForm);
USEFORM("RacourcisForm.cpp", RaccourcisForm);
USEFORM("Confirmform.cpp", Confirm);
USEFORM("EasterEggForm.cpp", EasterEgg);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int )
{
        try
        {
                CreateMutex( NULL, FALSE, "H2ONetSender" );
                if ( GetLastError() == ERROR_ALREADY_EXISTS )
                {
                        Application->MessageBox( "H.2.O Net Sender est dj ouvert", "Erreur", MB_ICONERROR );
                        return 0;
                }

                 Application->HintPause = 500 ;
                 Application->HintHidePause = 5000;
                 Application->Initialize();
                 Application->Title = "H.2.O Net Sender";
                 
                 Splash_dlg = new TSplash_dlg( NULL );     	// Cre la fiche dynamiquement
                 Splash_dlg->Show();               		// Affiche la fiche
                 Splash_dlg->Repaint();
                 Sleep( 700 );

                 Application->CreateForm(__classid(TH2ONetSender), &H2ONetSender);
                 Application->CreateForm(__classid(TRaccourcisForm), &RaccourcisForm);
                 delete Splash_dlg; // Supprime la fiche et libre la mmoire utilise

                 Application->Run();
        }
        catch (Exception &exception)
        {
                 Application->MessageBox( "Erreur inattendue au lancement du programme", "Erreur", MB_ICONERROR );
                 return 0;
        }
        catch (...)
        {
                 try
                 {
                         throw Exception("");
                 }
                 catch (Exception &exception)
                 {
                         Application->MessageBox( "Erreur au lancement du programme", "Erreur", MB_ICONERROR );
                         return 0;
                 }
        }
        return 0;
}
//---------------------------------------------------------------------------
