//---------------------------------------------------------------------------

#include <inifiles.hpp>                 // Pour la gestion des fichier ".ini"
#include <vcl.h>
#pragma hdrstop

#include "NetSenderForm.h"
#include "H2OFonctions.h"
#include "ThreadPrevisualiser.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

__fastcall ThreadPrevisualiser::ThreadPrevisualiser(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall ThreadPrevisualiser::Execute()
{
////////////////////////
// Mise en pause ??? ///
////////////////////////

        bool Pause = false;

        TIniFile *Ini;
        Ini = new TIniFile( ExtractFilePath( Application->ExeName ) + "Options.ini");

        if ( H2OFonctions::IsServiceRunning() == false )  // Vrif service msg
        {
                H2ONetSender->StatusBar->Panels->Items[0]->Text = "Mise en pause de l'Anti-Net Send...";
                if ( ( Ini->ReadBool( "ANS", "Pause", false ) == true ) || ( H2ONetSender->Conf->ShowModal() == mrYes ) )
                {
                          Pause = true;

                          H2ONetSender->FeuxRouge->Visible = false;    //
                          H2ONetSender->FeuxVert->Visible = false;     // Feux Orange pour le traitement
                          H2ONetSender->FeuxOrange->Visible = true;    /////////////////////////////////

                          H2ONetSender->Timer->Enabled = false;
                          WinExec( "net start msg", SW_HIDE );     // on dmarre

                          int a = 0;
                          while( !H2OFonctions::IsServiceRunning() )   // Tant que le service est arret
                          {
                                H2ONetSender->ProgressBar->Position = a;
                                Application->ProcessMessages();

                                Sleep( (unsigned long) 300 );
                                if ( a == 30 )break;
                                a++;
                          }
                          H2ONetSender->ProgressBar->Position = 0;

                          if ( H2OFonctions::IsServiceRunning() == false ) // re test pour voir si dmarrage effectuer
                          {
                                  H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : ACTIVER";
                                  H2ONetSender->Systray->Hint = "H.2.O Net Sender (Activer)";

                                  TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[5];
                                  ItemToEdit->Caption = "Dsactiver";

                                  H2ONetSender->StatusBar->Panels->Items[0]->Text = "Mise en pause impossible: Envoi annul";
                                  MessageBeep( MB_ICONEXCLAMATION );
                                  H2ONetSender->Timer->Enabled = false;
                                  H2ONetSender->Timer->Enabled = true;

                                  H2ONetSender->AntiNetSend->Caption = "Dsactiver";
                                  H2ONetSender->AntiNetSend->Hint = "Cliquer pour dsactiver la protection Anti-Net Send (Ctrl+D)";
                                  H2ONetSender->FeuxVert->Visible = false;
                                  H2ONetSender->FeuxRouge->Visible = true;
                                  H2ONetSender->FeuxOrange->Visible = false;
                                  return;
                          }
                          else
                          {
                                  H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : EN PAUSE";
                                  H2ONetSender->Systray->Hint = "H.2.O Net Sender (Pause)";

                                  TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                                  ItemToEdit->Items[0]->Caption = "Activer";

                                  H2ONetSender->AntiNetSend->Caption = "Activer";
                                  H2ONetSender->AntiNetSend->Hint = "Cliquer pour activer la protection Anti-Net Send (Ctrl+A)";
                          }
                }
                else           // service  ne pas mettre en pause
                {
                        H2ONetSender->StatusBar->Panels->Items[0]->Text = "Mise en pause de l'Anti-Net Send...";
                        return;
                }

        }

        delete Ini;

        H2ONetSender->StatusBar->Panels->Items[0]->Text = "Envoi en cours...";
        Application->ProcessMessages();

        char name[255];
        char strDestinataire[32] = "";

        if( gethostname( name, sizeof( name ) ) == 0 )
                strcat( strDestinataire, name );
        else
                strcat( strDestinataire, "127.0.0.1" );

        char strExpediteur[32];
        char strMessage[879];

        StrPCopy( strExpediteur, H2ONetSender->NomExpEdit->Text );   // Rcupration de l'expediteur
        StrPCopy( strMessage, H2ONetSender->MessageEdit->Text );    // Rcupration du message

        if ( H2OFonctions::SendMessage( strExpediteur, strDestinataire, strMessage ) != true )
             Application->MessageBox( "Impossible de prvisualiser le message", "Erreur", MB_ICONEXCLAMATION );

                    // Coding + Warning a corriger !!!
        if ( Pause == true )
        {
                H2ONetSender->StatusBar->Panels->Items[0]->Text = "Ractivation de l'Anti-Net Send...";
                WinExec( "net stop msg", SW_HIDE );     // on re de la pause stop

                while( H2OFonctions::IsServiceRunning() )   // Tant que le service est dmarrer
                {
                      Sleep( (unsigned long) 100 );
                }

                H2ONetSender->Timer->Enabled = false;
                H2ONetSender->Timer->Enabled = true;
                H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : ACTIVER";
                H2ONetSender->Systray->Hint = "H.2.O Net Sender (Activer)";

                TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                ItemToEdit->Items[0]->Caption = "Dsactiver";

                H2ONetSender->AntiNetSend->Caption = "Dsactiver";
                H2ONetSender->AntiNetSend->Hint = "Cliquer pour dsactiver la protection Anti-Net Send (Ctrl+D)";
                H2ONetSender->FeuxVert->Visible = false;
                H2ONetSender->FeuxRouge->Visible = true;
                H2ONetSender->FeuxOrange->Visible = false;
        }
        H2ONetSender->StatusBar->Panels->Items[0]->Text = "Prt";
}
//---------------------------------------------------------------------------
 