//---------------------------------------------------------------------------

#include <inifiles.hpp>                 // Pour la gestion des fichier ".ini"
#include <vcl.h>
#pragma hdrstop

#include "NetSenderForm.h"
#include "H2OFonctions.h"
#include "ThreadSendMsg.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

struct fiche                            // Structure pour la sauvegarde historique
{
        char DateTime[50];
        int NumMsg;                       // Rcupration valeur nombre message
        bool ChkMsg;                      // Bouton "Indiquer numro msg"
                                          //    Structure pour la gestion des fiches
        char Exp[32];                     // Rcupration de l'expediteur
        char Dest[32];                    // Rcupration du (des) destinataire(s)
        char msg[878];                    // Rcupration du mssage
};


__fastcall ThreadSendMsg::ThreadSendMsg(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall ThreadSendMsg::Execute()
{
////////////////////////
// Mise en pause ??? ///
////////////////////////

        bool Pause = false;

        TIniFile *Ini;
        Ini = new TIniFile( ExtractFilePath( Application->ExeName ) + "Options.ini");

        if ( H2OFonctions::IsServiceRunning() == false )  // Vrif service msg
        {
                H2ONetSender->StatusBar->Panels->Items[0]->Text = "Mise en pause de l'Anti-Net Send...";
                if ( ( Ini->ReadBool( "ANS", "Pause", false ) == true ) || ( H2ONetSender->Conf->ShowModal() == mrYes ) )
                {
                          Pause = true;

                          H2ONetSender->FeuxRouge->Visible = false;    //
                          H2ONetSender->FeuxVert->Visible = false;     // Feux Orange pour le traitement
                          H2ONetSender->FeuxOrange->Visible = true;    /////////////////////////////////

                          H2ONetSender->Timer->Enabled = false;

                          WinExec( "net start msg", SW_HIDE );     // on dmarre

                          int a = 0;
                          while( !H2OFonctions::IsServiceRunning() )   // Tant que le service est arret
                          {
                                Application->ProcessMessages();

                                H2ONetSender->ProgressBar->Position = a;

                                Sleep( (unsigned long) 300 );
                                if ( a == 30 )break;
                                a++;
                          }

                          H2ONetSender->ProgressBar->Position = 0;

                          if ( H2OFonctions::IsServiceRunning() == false ) // re test pour voir si dmarrage effectuer
                          {
                                  H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : ACTIVER";
                                  H2ONetSender->Systray->Hint = "H.2.O Net Sender (Activer)";

                                  TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                                  ItemToEdit->Items[0]->Caption = "Dsactiver";

                                  H2ONetSender->StatusBar->Panels->Items[0]->Text = "Envoi impossible, Anti-Net Send activ";
                                  MessageBeep( MB_ICONEXCLAMATION );
                                  H2ONetSender->Timer->Enabled = false;
                                  H2ONetSender->Timer->Enabled = true;

                                  H2ONetSender->AntiNetSend->Caption = "Dsactiver";
                                  H2ONetSender->AntiNetSend->Hint = "Cliquer pour dsactiver la protection Anti-Net Send (Ctrl+D)";
                                  H2ONetSender->FeuxVert->Visible = false;
                                  H2ONetSender->FeuxRouge->Visible = true;
                                  H2ONetSender->FeuxOrange->Visible = false;
                                  return;
                          }
                          else
                          {
                                  H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti-Net Send : EN PAUSE";
                                  H2ONetSender->Systray->Hint = "H.2.O Net Sender (Pause)";

                                  TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                                  ItemToEdit->Items[0]->Caption = "Activer";

                                  H2ONetSender->AntiNetSend->Caption = "Activer";
                                  H2ONetSender->AntiNetSend->Hint = "Cliquer pour activer la protection Anti-Net Send (Ctrl+A)";
                          }
                }
                else           // service  ne pas mettre en pause
                {
                        H2ONetSender->StatusBar->Panels->Items[0]->Text = "Prt";
                        return;
                }
        }

        // Minimizer a chaque envoi
        if ( Ini->ReadBool( "General", "MiniSend", false ) == true )
                H2ONetSender->Systray->Minimize();

        delete Ini;

        H2ONetSender->Timer->Enabled = false;
        H2ONetSender->StatusBar->Panels->Items[0]->Text = "Message(s) en cours d'envoi...";
        Application->ProcessMessages();

// Sauvegarde Expditeur et destinataire
////////////////////////////////////////
        int TestExp = 0, TestDest = 0;

        for ( int j = 0; j < 30; j++ )
        {
                if ( H2ONetSender->NomExpEdit->Text == H2ONetSender->NomExpEdit->Items->Strings[j] )
                        TestExp = 1;
                if ( H2ONetSender->NomDestRadio->Checked == true )
                {
                        if ( H2ONetSender->NomDestEdit->Text == H2ONetSender->NomDestEdit->Items->Strings[j] )
                                TestDest = 1;
                }
                if ( H2ONetSender->NomDestRadio->Checked == false )
                          TestDest = -1;
        }
        if ( TestExp == 0 )
                H2ONetSender->NomExpEdit->Items->Insert( 0, H2ONetSender->NomExpEdit->Text );
        if ( TestDest == 0 )
                H2ONetSender->NomDestEdit->Items->Insert( 0, H2ONetSender->NomDestEdit->Text );

        Ini = new TIniFile(ExtractFilePath(Application->ExeName ) + "Options.ini");

        for ( int a = 0; a < 30; a++ )
        {
                Ini->WriteString( "Save", "Exp" + IntToStr( a ), H2ONetSender->NomExpEdit->Items->Strings[a] );
                Ini->WriteString( "Save", "Dest" + IntToStr( a ), H2ONetSender->NomDestEdit->Items->Strings[a] );
        }

// Rcolte info
/////////////////////////////

        AnsiString Exp;           //
        AnsiString Dest;          //
        AnsiString Msg;           //
        bool IndNumMsg;           //
        int nbreBoucle;           //
        char strExpediteur[32];   //
        char strDestinataire[32]; // Dclarations variables
        char strMessage[879];     //
        bool TestEnvoi = true;    //
        int nbreEnvoi = 0;        /////////////////////////
        float PosEnvoi = 0;


// Rcupration du nbre de message a envoyer
        nbreBoucle = StrToInt( H2ONetSender->NombreMessageEdit->Text );

// Rcupration de la valeur du CheckBox NumeroMessageCheck (bool)
        IndNumMsg = H2ONetSender->NumeroMessageCheck->Checked;

// Rcupration de l'expediteur
        StrPCopy( strExpediteur, H2ONetSender->NomExpEdit->Text );

// Envoi a un seul destinataire
        if ( H2ONetSender->NomDestRadio->Checked == true )
        {
                PosEnvoi = 0;
                H2ONetSender->ProgressBar->Position = PosEnvoi;

                StrPCopy( strDestinataire, H2ONetSender->NomDestEdit->Text );

                for ( int i = 1; i <= nbreBoucle; i++ )
                {             // Boucle pour chaque msg a envoyer
                        if ( IndNumMsg == true )
                                Msg = ( IntToStr( i ) + " / " + AnsiString(nbreBoucle) + " : " + H2ONetSender->MessageEdit->Text );
                        else
                                Msg = H2ONetSender->MessageEdit->Text;

                        StrPCopy( strMessage, Msg );    // Rcupration du message

                        TestEnvoi = H2OFonctions::SendMessage( strExpediteur, strDestinataire, strMessage );

                        Application->ProcessMessages();     // Garder la main lors de l'envoi
                        if ( TestEnvoi == false )
                                break;
                        else
                        {
                                nbreEnvoi++;
                                PosEnvoi += (30.0 / nbreBoucle);
                                H2ONetSender->ProgressBar->Position = PosEnvoi;
                        }
                }

                H2ONetSender->ProgressBar->Position = 0;

                if ( TestEnvoi == true )
                {
                        if ( nbreEnvoi == 0 )
                        {
                                char Imposs[256] = "Le destinataire (";
                                strcat( Imposs, strDestinataire );
                                strcat( Imposs, ") ne peut pas recevoir de message" );
                                Application->MessageBox( Imposs, "Information", MB_ICONINFORMATION );
                                H2ONetSender->StatusBar->Panels->Items[0]->Text = "Prt";
                        }
                        if ( nbreBoucle == 1 )
                        {
                                H2ONetSender->StatusBar->Panels->Items[0]->Text = "Le message a t envoy !";
                                MessageBeep( MB_OK );
                                H2ONetSender->Timer->Enabled = false;
                                H2ONetSender->Timer->Enabled = true;
                        }
                        else
                        {
                                H2ONetSender->StatusBar->Panels->Items[0]->Text = IntToStr( nbreEnvoi ) + " / " + nbreBoucle + " messages ont t envoys !";
                                MessageBeep( MB_OK );
                                H2ONetSender->Timer->Enabled = false;
                                H2ONetSender->Timer->Enabled = true;
                        }
                }
                if ( ( TestEnvoi == true ) && ( nbreEnvoi != 0 ) )     // Save historique !!!
                {
                        // Sauvegarde message ?
                        if ( Ini->ReadBool("Historique", "Save", true ) == true )
                        {
                                // Test si la taille du fichier ne depasse pas celle saisie ds les options
                                // Une structure = 1000
                                int fichier;

                                if ( !FileExists( "Historique.log" ) )
                                        fichier = FileCreate( "Historique.log" );
                                else
                                        fichier = FileOpen( "Historique.log", fmOpenReadWrite );

                                if ( (FileSeek( fichier, 0, 2 ) < ( Ini->ReadInteger("Historique", "Max", 1000 ) * 1000 )) || (!Ini->ReadBool("Historique", "Limit", true )) )
                                {
                                        struct fiche save;

                                        StrPCopy( save.Exp, H2ONetSender->NomExpEdit->Text );

                                        StrPCopy( save.Dest, H2ONetSender->NomDestEdit->Text );

                                        save.NumMsg = StrToInt( H2ONetSender->NombreMessageEdit->Text );
                                        save.ChkMsg = H2ONetSender->NumeroMessageCheck->Checked;
                                        StrPCopy( save.msg, H2ONetSender->MessageEdit->Text );

                                        AnsiString Temp = DateToStr( Date() ) + " " + TimeToStr( Time() );
                                        StrPCopy( save.DateTime, Temp );

                                        FileWrite( fichier, &save, sizeof( struct fiche ));
                                        FileClose( fichier );
                                }
                                else
                                {
                                        struct fiche save;

                                        FileSeek( fichier, 0, 0 );
                                        FileRead( fichier, &save, sizeof( struct fiche ));

                                        for ( int Comp = 0; Comp < Ini->ReadInteger("Historique", "Max", 1000 ); Comp++ )
                                        {
                                                FileRead( fichier, &save, sizeof( struct fiche ));

                                                FileSeek( fichier, 1000 * Comp, 0 );
                                                FileWrite( fichier, &save, sizeof( struct fiche ) );
                                                FileSeek( fichier, 1000, 1 );
                                        }
                                        FileSeek( fichier, -2000, 1 );
                                        StrPCopy( save.Exp, H2ONetSender->NomExpEdit->Text );

                                        StrPCopy( save.Dest, H2ONetSender->NomDestEdit->Text );

                                        save.NumMsg = StrToInt( H2ONetSender->NombreMessageEdit->Text );
                                        save.ChkMsg = H2ONetSender->NumeroMessageCheck->Checked;
                                        StrPCopy( save.msg, H2ONetSender->MessageEdit->Text );

                                        AnsiString Temp = DateToStr( Date() ) + " " + TimeToStr( Time() );
                                        StrPCopy( save.DateTime, Temp );

                                        FileWrite( fichier, &save, sizeof( struct fiche ));
                                        FileClose( fichier );
                                }
                        }
                }
                if ( TestEnvoi == false )
                {
                        char Imposs[256] = "Le destinataire (";
                        strcat( Imposs, strDestinataire );
                        strcat( Imposs, ") ne peut pas recevoir de message" );
                        Application->MessageBox( Imposs, "Information", MB_ICONINFORMATION );
                }
        }

        if ( H2ONetSender->ListeDestRadio->Checked == true )
        {             // Liste de plusieurs destinataire

                char DestSuiv[1024];

                ZeroMemory(DestSuiv,1024);

                strcat( DestSuiv, "Le(s) destinataire(s) suivant ne peuvent pas recevoir de message :\n\t" );

                BOOL AffErr = false;
                int nbreIpSelect = 0;
                int nbreIp = 0, DestError = 0;
                nbreIp = H2ONetSender->DestListe->Count;     // Recupration du nombre de destinataire ds la liste

                H2ONetSender->ProgressBar->Position = PosEnvoi;

                int IpSelect = 0;
                for (int k = 0;k<nbreIp;k++)
                    if ( H2ONetSender->DestListe->State[k] )IpSelect++;

                for ( int i = 0; i < nbreIp; i++ )
                {          // Boucle pour chaque destinataire
                        if ( H2ONetSender->DestListe->State[i] == true )
                        {
                                nbreIpSelect++;

                                StrPCopy( strDestinataire, H2ONetSender->DestListe->Items->Strings[i] );

                                for ( int j = 1; j <= nbreBoucle; j++ )
                                {      // Boucle pour chaque msg a envoyer par destinataire
                                        if ( IndNumMsg == true )
                                                Msg = ( IntToStr( j ) + " / " + AnsiString(nbreBoucle) + " : " + H2ONetSender->MessageEdit->Text );
                                        else
                                                Msg = H2ONetSender->MessageEdit->Text;

                                        StrPCopy( strMessage, Msg );    // Rcupration du message

                                        TestEnvoi = H2OFonctions::SendMessage( strExpediteur, strDestinataire, strMessage );

                                        Application->ProcessMessages();     // Garder la main lors de l'envoi
                                        if ( TestEnvoi == false )
                                                break;
                                        else
                                        {
                                                nbreEnvoi++;
                                                PosEnvoi += (30.0 / nbreBoucle) / IpSelect;
                                                H2ONetSender->ProgressBar->Position = PosEnvoi;
                                        }
                                }

                                if ( TestEnvoi == true )
                                {
                                        if ( nbreEnvoi == 0 )
                                        {
                                                AffErr = true;
                                                strcat( DestSuiv, strDestinataire );
                                                strcat( DestSuiv, "\n\t" );
                                                DestError++;
                                        }
                                }
                                if ( TestEnvoi == false )
                                {
                                         AffErr = true;
                                         strcat( DestSuiv, strDestinataire );
                                         strcat( DestSuiv, "\n\t" );
                                         DestError++;
                                }
                                if ( ( TestEnvoi == true ) && ( nbreEnvoi != 0 ) )   //  Save ds historique
                                {
                                        // Sauvegarde message ?
                                        if ( Ini->ReadBool("Historique", "Save", true ) == true )
                                        {
                                                // Test si la taille du fichier ne depasse pas celle saisie ds les options
                                                // Une structure = 1000
                                                int fichier;

                                                if ( !FileExists( "Historique.log" ) )
                                                        fichier = FileCreate( "Historique.log" );
                                                else
                                                        fichier = FileOpen( "Historique.log", fmOpenReadWrite );

                                                if ( (FileSeek( fichier, 0, 2 ) < ( Ini->ReadInteger("Historique", "Max", 1000 ) * 1000 )) || (!Ini->ReadBool("Historique", "Limit", true ) ) )
                                                {
                                                        struct fiche save;

                                                        StrPCopy( save.Exp, H2ONetSender->NomExpEdit->Text );

                                                        StrPCopy( save.Dest, H2ONetSender->DestListe->Items->Strings[i] );

                                                        save.NumMsg = StrToInt( H2ONetSender->NombreMessageEdit->Text );
                                                        save.ChkMsg = H2ONetSender->NumeroMessageCheck->Checked;
                                                        StrPCopy( save.msg, H2ONetSender->MessageEdit->Text );

                                                        AnsiString Temp = DateToStr( Date() ) + " " + TimeToStr( Time() );
                                                        StrPCopy( save.DateTime, Temp );

                                                        FileWrite( fichier, &save, sizeof( struct fiche ));
                                                        FileClose( fichier );
                                                }
                                                else
                                                {
                                                        struct fiche save;

                                                        FileSeek( fichier, 0, 0 );
                                                        FileRead( fichier, &save, sizeof( struct fiche ));

                                                        for ( int Comp = 0; Comp < Ini->ReadInteger("Historique", "Max", 1000 ); Comp++ )
                                                        {
                                                                FileRead( fichier, &save, sizeof( struct fiche ));

                                                                FileSeek( fichier, 1000 * Comp, 0 );
                                                                FileWrite( fichier, &save, sizeof( struct fiche ) );
                                                                FileSeek( fichier, 1000, 1 );
                                                        }
                                                        FileSeek( fichier, -2000, 1 );
                                                        StrPCopy( save.Exp, H2ONetSender->NomExpEdit->Text );

                                                        StrPCopy( save.Dest, H2ONetSender->DestListe->Items->Strings[i] );

                                                        save.NumMsg = StrToInt( H2ONetSender->NombreMessageEdit->Text );
                                                        save.ChkMsg = H2ONetSender->NumeroMessageCheck->Checked;
                                                        StrPCopy( save.msg, H2ONetSender->MessageEdit->Text );

                                                        AnsiString Temp = DateToStr( Date() ) + " " + TimeToStr( Time() );
                                                        StrPCopy( save.DateTime, Temp );

                                                        FileWrite( fichier, &save, sizeof( struct fiche ));
                                                        FileClose( fichier );
                                                }
                                        }
                                }
                        }
                }
                H2ONetSender->ProgressBar->Position = 0;
                if ( ( nbreBoucle == 1 ) && ( nbreIpSelect == 1 ) && ( TestEnvoi == true ) )
                {
                        H2ONetSender->StatusBar->Panels->Items[0]->Text = "Le message a t envoy !";
                        MessageBeep( MB_OK );
                        H2ONetSender->Timer->Enabled = false;
                        H2ONetSender->Timer->Enabled = true;
                }
                else
                {
                        if ( nbreEnvoi == 0 );            // Pour laisser le msg d'erreur du thread
                        else
                        {
                                H2ONetSender->StatusBar->Panels->Items[0]->Text = IntToStr( nbreEnvoi ) + " / " + ( nbreBoucle * nbreIpSelect ) + " messages ont t envoys !";
                                MessageBeep( MB_OK );
                                H2ONetSender->Timer->Enabled = false;
                                H2ONetSender->Timer->Enabled = true;
                        }
                }

                if ( AffErr == true )              // Dest n'ayant pas recu de message !!!
                {
                        Application->MessageBox( DestSuiv, "Information", MB_ICONINFORMATION );
                        for ( int m = 0; m < 512; m++ )
                                DestSuiv[m] = '\0';
                }
        }

        H2ONetSender->CloseNetSended->Enabled = true;
        H2ONetSender->AntiNetSend->Enabled = true;
        Ini->WriteBool("General","Flood",false);

        // Effacer apres chaque envoi
        if ( Ini->ReadBool( "General", "EraseSend", false ) == true )
        {
                for ( int l = 0; l < H2ONetSender->DestListe->Count; l++ )
                        H2ONetSender->DestListe->State[l] = cbUnchecked;

                H2ONetSender->Effacer1Click( NULL );
        }

        delete Ini;

        if ( Pause == true )
        {
                H2ONetSender->StatusBar->Panels->Items[0]->Text = "Ractivation de l'Anti-Net Send...";
                WinExec( "net stop msg", SW_HIDE );     // on re de la pause stop

                while( H2OFonctions::IsServiceRunning() )   // Tant que le service est dmarrer
                {
                      Sleep( (unsigned long) 100 );
                }

                H2ONetSender->Timer->Enabled = false;
                H2ONetSender->Timer->Enabled = true;
                H2ONetSender->StatusBar->Panels->Items[2]->Text = "Anti Net Send : ACTIVER";
                H2ONetSender->Systray->Hint = "H.2.O Net Sender (Activer)";

                TMenuItem *ItemToEdit = H2ONetSender->PopupMenu->Items->Items[4];
                ItemToEdit->Items[0]->Caption = "Dsactiver";

                H2ONetSender->AntiNetSend->Caption = "Dsactiver";
                H2ONetSender->AntiNetSend->Hint = "Cliquer pour dsactiver la protection Anti-Net Send (Ctrl+D)";
                H2ONetSender->FeuxVert->Visible = false;
                H2ONetSender->FeuxRouge->Visible = true;
                H2ONetSender->FeuxOrange->Visible = false;
        }
}
//---------------------------------------------------------------------------
